Cabal-Version:            3.0
Name:                     scg-compiler
Version:                  1.0.0
Author:                   MIxAxIM
Maintainer:               gimbalabs.com
Build-Type:               Simple
License:                  GPL-3.0-or-later
License-file:             ../LICENSE

Common project-config
  default-language:       Haskell2010
  default-extensions:     NoImplicitPrelude
                          OverloadedStrings
                          ExplicitForAll
                          ScopedTypeVariables
                          DeriveGeneric
                          StandaloneDeriving
                          DeriveLift
                          GeneralizedNewtypeDeriving
                          DeriveFunctor
                          DeriveFoldable
                          DeriveTraversable
                          LambdaCase
                          MultiParamTypeClasses
                          TypeOperators
                          FlexibleInstances
                          NamedFieldPuns
                          TypeFamilies
                          FlexibleContexts
                          DeriveAnyClass
                          DerivingStrategies
                          DerivingVia
                          DataKinds
                          PatternGuards
                          -- OverloadedRecordFields

  ghc-options:            -Wall
                          -Wcompat
                          -Wincomplete-record-updates
                          -Wnoncanonical-monad-instances
                          -Wredundant-constraints
                          -Wincomplete-uni-patterns
                          -Wunused-packages
                          -Widentities
                          -rtsopts
                          -fno-ignore-interface-pragmas
                          -fno-omit-interface-pragmas
                          -fobject-code
                          -fno-specialise
                          -fno-spec-constr
                          -fno-strictness

Library
  import:                 project-config
  hs-source-dirs:         src
  exposed-modules:
                        WriteAll

                        ArenaOneCompilers.A1DATMinterCompiler
                        ArenaOneCompilers.A1GateKeeperCompiler
                        ArenaOneCompilers.A1RefUTxOIssuerCompiler

                        GovernanceCompilers.AccessControlCompiler
                        GovernanceCompilers.SenateCompiler




  build-depends:
                          base
                        , aeson
                        , bytestring
                        , cardano-api
                        , directory
                        , filepath
                        , plutus-core
                        , plutus-ledger
                        , plutus-ledger-api
                        , plutus-tx
                        , plutus-tx-plugin
                        , plutonomy
                        , serialise
                        , split
                        , plutus-script-utils
                        , scg-contracts
                        , scg-json-builder
                        , scg-types
